'Global command declaration
Global Command_Type
Global Addr
Global Axis


'*** this needs to be the right path

'this is a test function for the dll, it adds 1 to a number
Declare Function Test Lib "c:\vb\clci500\cuser2.dll" (ByVal Numb%) As Integer
'similar to the Out command in QuickBASIC
Declare Sub Out Lib "c:\vb\clci500\cuser2.dll" (ByVal Addr%, ByVal Byte%)
'similar to the Inp command in QuickBASIC
Declare Function Inp Lib "c:\vb\clci500\cuser2.dll" (ByVal Addr%) As Integer

Sub ACCEL (Hex_Address, Axis, Number)
 SEND_ASCII Hex_Address, Axis, "A"
 SEND_BINARY Hex_Address, Axis, Number, 1
End Sub

Function BASE_RATE (Hex_Address, Axis, Base_Speed, Max_Speed)
'this selects the appropriate base rate setting
'AA use only

  crystal! = 11000000#
 
  Factor_A = Int(crystal! / (Max_Speed * (8100 - 30 * 255)))
 
  BASE_RTE = Int((8100 - crystal! / (Base_Speed * Factor_A)) / 30 + .5)
  If BASE_RTE < 1 Then BASE_RTE = 1
  BASE_RATE = BASE_RTE
End Function

Sub BASE_SPD (Hex_Address, Axis, Number)
'this send the base rate
'AA use only
 SEND_ASCII Hex_Address, Axis, "B"
 SEND_BINARY Hex_Address, Axis, Number, 1
End Sub

Function BUSY (Hex_Address, Axis)
'this will return a 1 if it is BUSY meaning LOW
'this will return a 0 if it is not BUSY meaning HIGH

A = Inp(Hex_Address)                          'BUSY is the odd bit here
  If Axis = 1 Then
        If A Mod 2 = 1 Then
                BUSY = 0
        Else
                BUSY = 1
        End If
  Else
        If A >= 8 Then A = A - 8
        If A >= 4 Then
                BUSY = 0
        Else
                BUSY = 1
        End If
  End If
End Function

Function BYTE_COUNT (A$)
'this counts the bytes for programming the SMC20.
'AA use only

        Select Case A$

        Case "ACCL"
        BYTE_COUNT = 2

        Case "BASE"
        BYTE_COUNT = 6

        Case "DECL"
        BYTE_COUNT = 2

        Case "GO"
        BYTE_COUNT = 1
     
        Case "GOTO"             'LIKE A LOOP WITH A 0
        BYTE_COUNT = 3

        Case "HOME"
        BYTE_COUNT = 2

        Case "INPT"
        BYTE_COUNT = 3
    
        Case "LOOP"
        BYTE_COUNT = 3

        Case "MAX"
        BYTE_COUNT = 6
     
        Case "NUM"
        BYTE_COUNT = 3

        Case "OUT"
        BYTE_COUNT = 3
     
        Case "POS"
        BYTE_COUNT = 3

        Case "QUIT"
        BYTE_COUNT = 1
     
        Case "UNTL"             '(WAIT)
        BYTE_COUNT = 2
     
        Case "WAIT"             '(EXPEND)
        BYTE_COUNT = 3
     
        Case "SETZ"
        BYTE_COUNT = 1

        Case "DIR+"
        BYTE_COUNT = 1
      
        Case "DIR-"
        BYTE_COUNT = 1
       
        Case Else
        BYTE_COUNT = 0

        End Select

End Function

Sub CCW (Hex_Address, Axis)
   SEND_ASCII Hex_Address, Axis, "-"
End Sub

Sub CW (Hex_Address, Axis)
   SEND_ASCII Hex_Address, Axis, "+"
End Sub

Function DB_IN_OUT (Hex_Address, Axis)
'this will return a 1 if it is ready to SEND data meaning LOW
'this will return a 0 if it is ready to RECEIVE data meaning HIGH
'AA use only

  
  A = Inp(Hex_Address)
  If Axis = 1 Then
        If A >= 8 Then A = A - 8
        If A >= 4 Then A = A - 4
        If A >= 2 Then
                DB_IN_OUT = 0
        Else
                DB_IN_OUT = 1
        End If
  Else                                    'Axis = 2
        If A >= 8 Then
                DB_IN_OUT = 0
        Else
                DB_IN_OUT = 1
        End If
  End If
End Function

Sub DECEL (Hex_Address, Axis, Number)
 SEND_ASCII Hex_Address, Axis, "D"
 SEND_BINARY Hex_Address, Axis, Number, 1
End Sub

Sub Factor (Hex_Address, Axis, Number)
 SEND_ASCII Hex_Address, Axis, "F"
 SEND_BINARY Hex_Address, Axis, Number, 1
End Sub

Sub FINISH (Hex_Address, Axis)
        While BUSY(Hex_Address, Axis)
        Wend
End Sub

Function GET_BASE_SPEED (Hex_Address, Axis)
        'this returns the actual base speed

  SEND_ASCII Hex_Address, Axis, "VF"
  Factor_C = RECEIVE(Hex_Address, Axis)

  SEND_ASCII Hex_Address, Axis, "VB"
  BASE_RTE = RECEIVE(Hex_Address, Axis)

  crystal! = 11000000#

  GET_BASE_SPEED = (crystal! / (Factor_C * (8100 - 30 * BASE_RTE)))
        'this calculates the actual speed
End Function

Function GET_INPUT (Hex_Address, Input_Number)
   Dim Address
   Address = Hex_Address + 6
   Value = Inp(Address)
   GET_INPUT = 1
      If Input_Number = 1 Then
         If Value >= 32 Then Value = Value - 32
         If Value >= 16 Then Value = Value - 16
         If Value >= 8 Then Value = Value - 8
         If Value >= 4 Then Value = Value - 4
         If Value >= 2 Then Value = Value - 2
         If Value = 1 Then GET_INPUT = 0
      End If
      If Input_Number = 2 Then
         If Value >= 32 Then Value = Value - 32
         If Value >= 16 Then Value = Value - 16
         If Value >= 8 Then Value = Value - 8
         If Value >= 4 Then Value = Value - 4
         If Value >= 2 Then GET_INPUT = 0
      End If
      If Input_Number = 3 Then
         If Value >= 32 Then Value = Value - 32
         If Value >= 16 Then Value = Value - 16
         If Value >= 8 Then Value = Value - 8
         If Value >= 4 Then GET_INPUT = 0
      End If
      If Input_Number = 4 Then
         If Value >= 32 Then Value = Value - 32
         If Value >= 16 Then Value = Value - 16
         If Value >= 8 Then GET_INPUT = 0
      End If
      If Input_Number = 5 Then
         If Value >= 32 Then Value = Value - 32
         If Value >= 16 Then GET_INPUT = 0
      End If
      If Input_Number = 6 Then
         If Value >= 32 Then GET_INPUT = 0
      End If
End Function

Function GET_INPUTS (Hex_Address)
        Dim Address

        Address = Hex_Address + 6
        GET_INPUTS = (63 - Inp(Address))
End Function

Function GET_MAX_SPEED (Hex_Address, Axis)
'this returns the actual max speed

  SEND_ASCII Hex_Address, Axis, "VF"
  Factor_B = RECEIVE(Hex_Address, Axis)

  SEND_ASCII Hex_Address, Axis, "VM"
  MAX_RTE = RECEIVE(Hex_Address, Axis)

crystal! = 11000000#

GET_MAX_SPEED = (crystal! / (Factor_B * (8100 - 30 * MAX_RTE)))
        'this calculates the actual speed

End Function

Function GET_PROGRAM (Hex_Address, Axis)
'AA use only
 
  'Print : Print
  'Print "data bus - "; DB_IN_OUT(Hex_Address, AXIS)
  'SEND_ASCII Hex_Address, AXIS, "VC"
  'Print "data bus - "; DB_IN_OUT(Hex_Address, AXIS)
  'While DB_IN_OUT(Hex_Address, AXIS) = 1
  '      Opcode = RECEIVE(Hex_Address, AXIS)
  '      Print "INDEX NUMBER: "; Chr$(Opcode); Opcode,
  '      Print "data bus - "; DB_IN_OUT(Hex_Address, AXIS)
  'Wend

End Function

Sub HOME (Hex_Address, Axis, Number)
 SEND_ASCII Hex_Address, Axis, "H"
 SEND_BINARY Hex_Address, Axis, Number, 1
End Sub

Sub INDEX (Hex_Address, Axis)
  Dim Address

  Address = Hex_Address
  SEND_ASCII Address, Axis, "G"
End Sub

Sub INDEX_NUMBER (Hex_Address, Axis, Number)
 SEND_ASCII Hex_Address, Axis, "N"
 SEND_BINARY Hex_Address, Axis, Number, 2
End Sub

Sub MAX (Hex_Address, Axis, Number)
'AA use only
 SEND_ASCII Hex_Address, Axis, "M"
 SEND_BINARY Hex_Address, Axis, Number, 1
End Sub

Sub MOTION (Hex_Address, Axis, Base_Speed, Max_Speed)
  crystal! = 11000000#
  If Base_Speed > 20000 Then Base_Speed = 20000
  If Base_Speed < 5 Then Base_Speed = 5
  If Max_Speed > 24444 Then Max_Speed = 24444
  If Max_Speed < 100 Then Max_Speed = 100

  Factor_A = Int(crystal! / (Max_Speed * (8100 - 30 * 255)))
        'truncated not rounded
        'this calculates the highest factor that can be used

'  PRINT "Factor: "; Factor_A

  MAX_RTE = Int((8100 - crystal! / (Max_Speed * Factor_A)) / 30 + .5)
        'this calculates the closest speed to that chosen
        'this rounds to the closest speed

'  PRINT "Max_Rate: "; Max_Rte

  BASE_RTE = Int((8100 - crystal! / (Base_Speed * Factor_A)) / 30 + .5)
        'this calculates the closest speed to that chosen
        'this rounds to the closest speed
  If BASE_RTE < 1 Then BASE_RTE = 1
        'this is the case that the base speed asked for is too small
  If BASE_RTE > 254 Then BASE_RTE = 254

'  PRINT "Base_Rate: "; Base_Rte

  BASE_SPD Hex_Address, Axis, BASE_RTE
  MAX Hex_Address, Axis, MAX_RTE
  Factor Hex_Address, Axis, Factor_A
End Sub

Function NUM_OF_AXES (Hex_Address)
    Dim Address
'this function will send an INDEX NUMBER to each potential axis
'if the number can be read back, then that axis is indeed valid.
'this function will return a 1 if axis 1 is valid
'                          a 2 if axis 1 and axis 2 is valid
'                          a 99 if axis 1 is NOT valid but axis 2 is

'AXIS 2 TEST
  Number = 12345
  Axis = 1
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 3

'SEND "N"
  A$ = "N"
  Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
  Out Add_Latch, Asc(A$)  'this latches the data on U7
  Out Add_Hand_Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
  Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI

'SEND NUMBER
  Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
  Out Add_Latch, Number Mod 256  'this latches the data on U7
  Out Add_Hand_Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
  Out Add_Hand_Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
  Out Add_Hand_Shake, 6        'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
  Out Add_Latch, Number \ 256  'this latches the data on U7
  Out Add_Hand_Shake, 4        'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
  Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI

'SEND "VN"
    A$ = "VN"
    For X = 1 To Len(A$)
      Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
      Out Add_Latch, Asc(Mid$(A$, X, 1))  'this latches the data on U7
      Out Add_Hand_Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
      Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
    Next X

'RECEIVE NUMBER
  Address = Hex_Address + 2
  PAUSE .1
  Out Hex_Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  
  'debug - put next line back in
  'A = Inp(ADDRESS)                          'read the data
  
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
  Out Hex_Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  B = Inp(Address)
  
  
  nA = nA + B * 256
  
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH

  
  If nA = 12345 Then NUM_AXES = 1


'AXIS 2 TEST
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 5
  A$ = "N"
  Number = 54321

'SEND "N"
    Out Add_Hand_Shake, 6 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Asc(A$)  'this latches the data on U7
    Out Add_Hand_Shake, 2 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI

'SEND NUMBER
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 2    'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    Out Add_Hand_Shake, 7      'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
    Out Add_Hand_Shake, 6         'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number \ 256  'this latches the data on U7
    Out Add_Hand_Shake, 2         'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to HI

'SEND "VN"
    A$ = "VN"
    For X = 1 To Len(A$)
      Out Add_Hand_Shake, 6 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
      Out Add_Latch, Asc(Mid$(A$, X, 1))  'this latches the data on U7
      Out Add_Hand_Shake, 2 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
      Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
    Next X

'RECEIVE NUMBER
    Address = Hex_Address + 4
    PAUSE .1
    Out Hex_Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
    nA = Inp(Address)                          'read the data
    Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
    Out Hex_Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
    B = Inp(Address)
    nA = nA + B * 256
    Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH

  If (nA = 54321) And (NUM_AXES = 1) Then NUM_AXES = 2
  If (nA = 54321) And (NUM_AXES = 0) Then NUM_AXES = 99

  'IF NUM_OF_AXES = 99 THEN SOMETHING IS WRONG WITH AXIS 1 BUT AXIS 2 IS OK
 
   NUM_OF_AXES = NUM_AXES

End Function

Sub PAUSE (B)
A = Timer
While Timer - A < B
Wend

End Sub

Sub POSITION (Hex_Address, Axis, Number)
 SEND_ASCII Hex_Address, Axis, "P"
 SEND_BINARY Hex_Address, Axis, Number, 2
End Sub

Sub PROG_HALT (Hex_Address, Axis)
    Add_Hand_Shake = Hex_Address + 1
    Add_Latch = Hex_Address + 3
   
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
                             'write control to LOW
    Out Add_Latch, Asc("Q")  'this latches the data on U7
   
    Out Add_Hand_Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
   
    'WHILE BUSY(Hex_Address, Axis) = 0     'wait for the chip to be BUSY
    'WEND                                  '(a logic 0) (it accepts the data)

End Sub

Sub PROG_RUN ()
  Dim Address

  Axis = 1
  Address = &H300
  SEND_ASCII Address, Axis, "R"
  SEND_BINARY Address, Axis, 0, 1
End Sub

Function RECEIVE (Hex_Address, Axis)
    Dim Address
'this is to receive one byte of data from the smc20 chip
'AA use only

        'we check for the busy to be HIGH
        'then we bring the i/o req low (meaning ready)
        'the smc20 brings the busy low and we check for this
        'then we read the data
        'then we bring the i/o req high
 
   If Axis = 1 Then
        Address = Hex_Address + 2
   Else                                 'Axis = 2
        Address = Hex_Address + 4
   End If

While BUSY(Hex_Address, Axis) = 1         'wait for the chip to not be BUSY
Wend

If Axis = 1 Then
  Out Hex_Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  While BUSY(Hex_Address, Axis) = 0         'wait for the chip to be BUSY
  Wend
  A = Inp(Address)                          'read the data
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
  RECEIVE = A

Else            'axis = 2
  Out Hex_Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
  While BUSY(Hex_Address, Axis) = 0         'wait for the chip to be BUSY
  Wend
  A = Inp(Address)                          'read the data
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
  RECEIVE = A
End If

End Function

Sub SEND_ASCII (Hex_Address, Axis, A$)
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

If Axis = 1 Then
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 3
  For X = 1 To Len(A$)
    While BUSY(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
    Wend                                '(a logic 1)
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
                             'write control to LOW
    Out Add_Latch, Asc(Mid$(A$, X, 1))  'this latches the data on U7
    Out Add_Hand_Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    While BUSY(Hex_Address, Axis) = 0     'wait for the chip to be BUSY
    Wend                                  '(a logic 0) (it accepts the data)
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If

If Axis = 2 Then
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 5
  For X = 1 To Len(A$)
  While BUSY(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
  Wend
  Out Add_Hand_Shake, 6 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
  Out Add_Latch, Asc(Mid$(A$, X, 1))  'this latches the data on U7
  Out Add_Hand_Shake, 2 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
  While BUSY(Hex_Address, Axis) = 0     'wait for the chip to be BUSY (accept the data)
  Wend
  Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If


End Sub

Sub SEND_BINARY (Hex_Address, Axis, Number, Bytes)
'this will send either 1 or 2 bytes, specified by the Bytes term
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

If Axis = 1 Then
        Add_Hand_Shake = Hex_Address + 1
        Add_Latch = Hex_Address + 3
  If Bytes = 1 Then
    While BUSY(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    A = Inp(Hex_Address)           'BUSY is the odd bit here
    While BUSY(Hex_Address, Axis) = 0  'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  End If

  If Bytes = 2 Then
    While BUSY(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    While BUSY(Hex_Address, Axis) = 0   'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
    While BUSY(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6        'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number \ 256  'this latches the data on U7
    Out Add_Hand_Shake, 4        'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    While BUSY(Hex_Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  End If
Else    'Axis = 2
        Add_Hand_Shake = Hex_Address + 1
        Add_Latch = Hex_Address + 5
  If Bytes = 1 Then
    While BUSY(Hex_Address, Axis) = 1   'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 2          'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    While BUSY(Hex_Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  End If
 
  If Bytes = 2 Then
    While BUSY(Hex_Address, Axis) = 1          'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 2    'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    While BUSY(Hex_Address, Axis) = 0          'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7      'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                               'resets i/o req
                             'disables data from the smc20's bus
    While BUSY(Hex_Address, Axis) = 1          'wait for the chip to not be BUSY
    Wend
    Out Add_Hand_Shake, 6         'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number \ 256  'this latches the data on U7
    Out Add_Hand_Shake, 2         'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    While BUSY(Hex_Address, Axis) = 0         'wait for the chip to be BUSY (accept the data)
    Wend
    Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  End If
End If
End Sub

Sub SEND_RUN (Hex_Address, Axis)
 SEND_ASCII Hex_Address, Axis, "R"
 SEND_BINARY Hex_Address, Axis, 0, 1
End Sub

Sub SET_OUTPUTS (Hex_Address, Out6, Out5, Out4, Out3, Out2, Out1)
       Dim Address
   Address = Hex_Address + 7
   Total = Out6 * 32 + Out5 * 16 + Out4 * 8 + Out3 * 4 + Out2 * 2 + Out1
   Out Address, Total
End Sub

Sub SETUP (Hex_Address)
'the 74HC373 chip may come up with the outputs in either a high or low state
'this subroutine will ensure that the outputs will be in the high state
'the SMC20 may get one byte of unknown data if the output was in the low state
 
  Out Hex_Address + 1, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI
                           'write control to HI
  Out Hex_Address + 7, 0   'this sets the outputs to an open state

End Sub

Sub Test_Index (Hex_Address, Axis, Number)
    Dim A
    
    N$ = "N"
'*** send ascii
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

If Axis = 1 Then
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 3
  For X = 1 To Len(N$)
    'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
    'Wend                                '(a logic 1)
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
                             'write control to LOW
    Out Add_Latch, Asc(Mid$(N$, X, 1))  'this latches the data on U7
    Out Add_Hand_Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    'While BUSY(Hex_Address, axis) = 0     'wait for the chip to be BUSY
    'Wend                                  '(a logic 0) (it accepts the data)
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If

If Axis = 2 Then
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 5
  For X = 1 To Len(N$)
  'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
  'Wend
  Out Add_Hand_Shake, 6 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
  Out Add_Latch, Asc(Mid$(N$, X, 1))  'this latches the data on U7
  Out Add_Hand_Shake, 2 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
  'While BUSY(Hex_Address, axis) = 0     'wait for the chip to be BUSY (accept the data)
  'Wend
  Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If


'****send binary
'this will send either 1 or 2 bytes, specified by the Bytes term
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

If Axis = 1 Then
        Add_Hand_Shake = Hex_Address + 1
        Add_Latch = Hex_Address + 3
  If Bytes = 1 Then
    'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
    'Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    A = Inp(Hex_Address)           'BUSY is the odd bit here
    'While BUSY(Hex_Address, axis) = 0  'wait for the chip to be BUSY (accept the data)
    'Wend
    Out Add_Hand_Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  End If

  If Bytes = 2 Then
    'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
    'Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 4          'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    'While BUSY(Hex_Address, axis) = 0   'wait for the chip to be BUSY (accept the data)
    'Wend
    Out Add_Hand_Shake, 7   'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
    'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
    'Wend
    Out Add_Hand_Shake, 6        'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number \ 256  'this latches the data on U7
    Out Add_Hand_Shake, 4        'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    'While BUSY(Hex_Address, axis) = 0         'wait for the chip to be BUSY (accept the data)
    'Wend
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  End If
Else    'Axis = 2
        Add_Hand_Shake = Hex_Address + 1
        Add_Latch = Hex_Address + 5
  If Bytes = 1 Then
    'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
    'Wend
    Out Add_Hand_Shake, 6          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 2          'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    'While BUSY(Hex_Address, axis) = 0         'wait for the chip to be BUSY (accept the data)
    'Wend
    Out Add_Hand_Shake, 7          'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                            'resets i/o req
                            'disables data from the smc20's bus
  End If
 
  If Bytes = 2 Then
    'While BUSY(Hex_Address, axis) = 1          'wait for the chip to not be BUSY
    'Wend
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number Mod 256  'this latches the data on U7
    Out Add_Hand_Shake, 2    'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    'While BUSY(Hex_Address, axis) = 0          'wait for the chip to be BUSY (accept the data)
    'Wend
    Out Add_Hand_Shake, 7      'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                               'resets i/o req
                             'disables data from the smc20's bus
    'While BUSY(Hex_Address, axis) = 1          'wait for the chip to not be BUSY
    'Wend
    Out Add_Hand_Shake, 6         'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
    Out Add_Latch, Number \ 256  'this latches the data on U7
    Out Add_Hand_Shake, 2         'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
    'While BUSY(Hex_Address, axis) = 0         'wait for the chip to be BUSY (accept the data)
    'Wend
    Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to HI
                          'resets i/o req
                          'disables data from the smc20's bus
  End If
End If



End Sub

Function Test_Receive (Hex_Address, Axis)
    Dim Address
'this is to receive one byte of data from the smc20 chip
'AA use only

        'we check for the busy to be HIGH
        'then we bring the i/o req low (meaning ready)
        'the smc20 brings the busy low and we check for this
        'then we read the data
        'then we bring the i/o req high
 
   If Axis = 1 Then
        Address = Hex_Address + 2
   Else                                 'Axis = 2
        Address = Hex_Address + 4
   End If

'While BUSY(Hex_Address, axis) = 1         'wait for the chip to not be BUSY
'Wend

If Axis = 1 Then
  Out Hex_Address + 1, 5   'A:I/O REQ LOW, B:I/O REQ HI, write control HIGH
  'While BUSY(Hex_Address, axis) = 0         'wait for the chip to be BUSY
  'Wend
  A = Inp(Address)                          'read the data
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
  Test_Receive = A

Else            'axis = 2
  Out Hex_Address + 1, 3   'A:I/O REQ HI, B:I/O REQ LOW, write control HIGH
  'While BUSY(Hex_Address, axis) = 0         'wait for the chip to be BUSY
  'Wend
  A = Inp(Address)                          'read the data
  Out Hex_Address + 1, 7   'A:I/O REQ HI, B:I/O REQ HI, write control HIGH
                        'resets i/o req
                        'disables data from the smc20's bus
  Test_Receive = A
End If

End Function

Function Test_Verify (adrr, Axis)
   B = 0
   C = 1
 
    N$ = "VN"
'*** send ascii
'AA use only
'This function will "hang up" if the chip is in motion - like a HOME or INDEX
'this can be avoided by checking the BUSY before issuing the command

If Axis = 1 Then
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 3
  For X = 1 To Len(N$)
    'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
    'Wend                                '(a logic 1)
    Out Add_Hand_Shake, 6    'this sets the A:I/O REQ to HI, B:I/O REQ to HI
                             'write control to LOW
    Out Add_Latch, Asc(Mid$(N$, X, 1))  'this latches the data on U7
    Out Add_Hand_Shake, 4 'this sets the A:I/O REQ to LOW, B:I/O REQ to HI, write control to LOW
    'While BUSY(Hex_Address, axis) = 0     'wait for the chip to be BUSY
    'Wend                                  '(a logic 0) (it accepts the data)
    Out Add_Hand_Shake, 7  'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If

If Axis = 2 Then
  Add_Hand_Shake = Hex_Address + 1
  Add_Latch = Hex_Address + 5
  For X = 1 To Len(N$)
  'While BUSY(Hex_Address, axis) = 1   'wait for the chip to not be BUSY
  'Wend
  Out Add_Hand_Shake, 6 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to LOW
  Out Add_Latch, Asc(Mid$(N$, X, 1))  'this latches the data on U7
  Out Add_Hand_Shake, 2 'this sets the A:I/O REQ to HI, B:I/O REQ to LOW, write control to LOW
  'While BUSY(Hex_Address, axis) = 0     'wait for the chip to be BUSY (accept the data)
  'Wend
  Out Add_Hand_Shake, 7 'this sets the A:I/O REQ to HI, B:I/O REQ to HI, write control to HI
                        'resets i/o req and disables data from the smc20's bus
  Next X
End If


'While DB_IN_OUT(Hex_Address, Axis) = 1
   vA = Test_Receive(Hex_Address, Axis)
   B = B + vA
   vA = Test_Receive(Hex_Address, Axis)
   B = B + vA * 256
   'Select Case C
   'Case 1
   'Case 2
   'Case 3
   '  B = B + vA * 65536
   'End Select
   'C = C + 1
   'Beep
'Wend
   Test_Verify = B

End Function

Function verify (Hex_Address, Axis, A$)
  
   B = 0
   C = 1
 
SEND_ASCII Hex_Address, Axis, ",V" + A$

While DB_IN_OUT(Hex_Address, Axis) = 1
   vA = RECEIVE(Hex_Address, Axis)
   Select Case C
   Case 1
     B = B + vA
   Case 2
     B = B + vA * 256
   Case 3
     B = B + vA * 65536
   End Select
   C = C + 1
Wend
   verify = B

End Function

Function VERIFY_PROGRAM$ (Hex_Address, Axis)
'AA use only
    A$ = ""
    B$ = ""
SEND_ASCII Hex_Address, Axis, ",VC"

   'A = RECEIVE
While DB_IN_OUT(Hex_Address, Axis) = 1
   'A = RECEIVE
   'A$ = Chr$(A)
  
   Select Case A$
   
        Case "A"
        'B$ = B$ + A$ + CHR$(RECEIVE)

        Case "B"
        'B$ = B$ + A$ + CHR$(RECEIVE)
       
        Case "D"
        'B$ = B$ + A$ + CHR$(RECEIVE)

        Case "F"
        'B$ = B$ + A$ + CHR$(RECEIVE)
        
        Case "G"
        B$ = B$ + A$

        Case "H"
        B$ = B$ + A$
        'A$ = CHR$(RECEIVE)
        'A$ = CHR$(RECEIVE)
       
        Case "I"
        'B$ = B$ + A$ + STR$(RECEIVE + 256 * RECEIVE)

        Case "J"
        'B$ = B$ + A$ + STR$(RECEIVE)
       
        Case "L"
        'B$ = B$ + A$ + STR$(RECEIVE + 256 * RECEIVE)
       
        Case "M"
        'B$ = B$ + A$ + STR$(RECEIVE)
       
        Case "N"
        'B$ = B$ + A$ + STR$(RECEIVE + 256 * RECEIVE)
       
        Case "Q"
        B$ = B$ + A$
       
        Case "X"
        'B$ = B$ + A$ + STR$(RECEIVE + 256 * RECEIVE)
                                     
        End Select
Wend
   VERIFY_PROGRAM$ = B$

End Function

Sub ZERO (Hex_Address, Axis)
 SEND_ASCII Hex_Address, Axis, "Z"
End Sub

