Attribute VB_Name = "C2000WIN"
'ANAHIEIM AUTOMATION
'DATE: 1/24/96
'BY: ALAN HARMON
'CALL 714/992-6990 FOR MORE INFORMATION

'this is a test function for the dll, it adds 1 to a number
Declare Function Test Lib "c:\windows\system\in_out32.dll" (ByVal Numb%) As Integer
'similar to the Out command in QuickBASIC
Declare Sub Out Lib "c:\windows\system\in_out32.dll" (ByVal Addr%, ByVal Numb%)
'similar to the Inp command in QuickBASIC
Declare Function Inp Lib "c:\windows\system\in_out32.dll" (ByVal Addr%) As Integer

Function BUSY(H_ADDRESS, X_NUMBER)
       ADDRESS = H_ADDRESS + 12 + X_NUMBER * 4

       Out ADDRESS, 128 + 10
       A = Inp(ADDRESS)
       If A >= 128 Then A = A - 128
       If A >= 64 Then
                BUSY = 1        'BUSY
        Else
                BUSY = 0        'NOT BUSY
        End If
End Function

Function GET_BASE(Base_Speed, MAX_Speed, RAMP_Value)
         OPTIMUM_FACTOR = 300! * 16383 / MAX_Speed
         FACTOR = Int(OPTIMUM_FACTOR)
         If FACTOR < 2 Then FACTOR = 2
         If FACTOR > 16383 Then FACTOR = 16383

         MAX_SETTING = Int(MAX_Speed * FACTOR / 300)
                If MAX_SETTING > 16383 Then MAX_SETTING = 16383

'this finds the RAMP
         RAMP_SETTING = Int((150! * 9830400) / (RAMP_Value * FACTOR))
         If RAMP_SETTING < 1 Then RAMP_SETTING = 1
         If RAMP_SETTING > 32767 Then RAMP_SETTING = 32767

         ACTUAL_RAMP = (150! * 9830400) / (RAMP_SETTING * FACTOR)

         BASE_SETTING = Int(Base_Speed * FACTOR / 300)
         If BASE_SETTING < 1 Then BASE_SETTING = 1

   GET_BASE = 300! * BASE_SETTING / FACTOR


End Function

Function GET_INPUT(Hex_Address, Input_Number)
       If Input_Number > 5 Then
                ADDRESS = Hex_Address + 8
                Input_Number = Input_Number - 5
       Else
                ADDRESS = Hex_Address
       End If

       Out ADDRESS, 8
       Value = Inp(ADDRESS)
       Value = Value - 128 - 64 - 32
      
            If Input_Number = 5 Then
                If Value >= 16 Then
                        GET_INPUT = 0
                Else
                        GET_INPUT = 1
                End If
            End If
      
       Value = Value Mod 16
            If Input_Number = 4 Then
                If Value >= 8 Then
                        GET_INPUT = 0
                Else
                        GET_INPUT = 1
                End If
            End If
      
       Value = Value Mod 8
            If Input_Number = 3 Then
                If Value >= 4 Then
                        GET_INPUT = 0
                Else
                        GET_INPUT = 1
                End If
            End If

       Value = Value Mod 4
            If Input_Number = 2 Then
                If Value >= 2 Then
                        GET_INPUT = 0
                Else
                        GET_INPUT = 1
                End If
            End If

       Value = Value Mod 2
            If Input_Number = 1 Then
                If Value = 1 Then
                        GET_INPUT = 0
                Else
                        GET_INPUT = 1
                End If
            End If

End Function

Sub GET_LO_Mid_HI(Value, HIBYTE, MIDBYTE, LOBYTE)
        
        HIBYTE = Int(Value / 65536)
        MIDBYTE = Int(Value / 256) Mod 256
        LOBYTE = Value Mod 256

End Sub

Function GET_MAX(Base_Speed, MAX_Speed, RAMP_Value)

'this will find the optimum FACTOR

         OPTIMUM_FACTOR = 300! * 16383 / MAX_Speed
         FACTOR = Int(OPTIMUM_FACTOR)
         If FACTOR < 2 Then FACTOR = 2
         If FACTOR > 16383 Then FACTOR = 16383
 
        MAX_SETTING = Int(MAX_Speed * FACTOR / 300)
                If MAX_SETTING > 16383 Then MAX_SETTING = 16383

   GET_MAX = 300! * MAX_SETTING / FACTOR

End Function

Function GET_RAMP(Base_Speed, MAX_Speed, RAMP_Value)
         OPTIMUM_FACTOR = 300! * 16383 / MAX_Speed
         FACTOR = Int(OPTIMUM_FACTOR)
         If FACTOR < 2 Then FACTOR = 2
         If FACTOR > 16383 Then FACTOR = 16383

        MAX_SETTING = Int(MAX_Speed * FACTOR / 300)
                If MAX_SETTING > 16383 Then MAX_SETTING = 16383
        RAMP_SETTING = Int((150! * 9830400) / (RAMP_Value * FACTOR))
        If RAMP_SETTING < 1 Then RAMP_SETTING = 1
        If RAMP_SETTING > 32767 Then RAMP_SETTING = 32767

        GET_RAMP = (150! * 9830400) / (RAMP_SETTING * FACTOR)

End Function

Sub GO_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4
       Out ADDRESS, 65
       Out ADDRESS, 23
End Sub

Sub GO_CW(Hex_Address, X_NUMBER)
    ADDRESS = Hex_Address + 12 + X_NUMBER * 4
    Out ADDRESS, 65
    Out ADDRESS, 19
End Sub

Function HARD_INPUT_CCW(Hex_Address, X_NUMBER)

       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 131
       LIMITS = Inp(ADDRESS + 1)
       LIMITS = LIMITS - 128
        If LIMITS \ 64 = 1 Then LIMITS = LIMITS - 64
        If LIMITS \ 32 = 1 Then LIMITS = LIMITS - 32
        If LIMITS \ 16 = 1 Then LIMITS = LIMITS - 16
        If LIMITS \ 8 = 1 Then LIMITS = LIMITS - 8
        If LIMITS \ 4 = 1 Then LIMITS = LIMITS - 4
        If LIMITS \ 2 = 1 Then
                HARD_INPUT_CCW = 1
        Else
                HARD_INPUT_CCW = 0
        End If
End Function

Function HARD_INPUT_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4
       Out ADDRESS, 131
       LIMITS = Inp(ADDRESS + 1)
                                        '128: RDY
                                        ' 64: EZ
                                        ' 32: ALM (HOME MULTIPLEXED)
                                        ' 16: ORG (TIED TO EZ)
                                        '  8: -SD (-SOFT LIMIT)
                                        '  4: +SD (+SOFT LIMIT)
                                        '  2: -EL (-HARD LIMIT)
                                        '  1: +EL (+HARD LIMIT)

        LIMITS = LIMITS - 128
        If LIMITS \ 64 = 1 Then LIMITS = LIMITS - 64
        If LIMITS \ 32 = 1 Then LIMITS = LIMITS - 32
        If LIMITS \ 16 = 1 Then LIMITS = LIMITS - 16
        If LIMITS \ 8 = 1 Then LIMITS = LIMITS - 8
        If LIMITS \ 4 = 1 Then LIMITS = LIMITS - 4
        If LIMITS \ 2 = 1 Then LIMITS = LIMITS - 2
        If LIMITS = 1 Then
                HARD_INPUT_CW = 1
        Else
                HARD_INPUT_CW = 0
        End If
End Function

Sub HOME_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 64
       Out ADDRESS, 23
End Sub

Sub HOME_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 64
       Out ADDRESS, 19
End Sub

Function HOME_INPUT(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 131
       LIMITS = Inp(ADDRESS + 1)
       
       LIMITS = LIMITS - 128
       If LIMITS \ 64 = 1 Then LIMITS = LIMITS - 64
       If LIMITS \ 32 = 1 Then
                HOME_INPUT = 1
       Else
                HOME_INPUT = 0
       End If
End Function

Sub Index(Hex_Address, X_NUMBER, Setting)
  ADDRESS = Hex_Address + 12 + X_NUMBER * 4

  
  Call GET_LO_Mid_HI(Setting, HI, Mid_Byte, LO)
  Out ADDRESS, 128 + 0
  Out ADDRESS + 1, LO
  Out ADDRESS + 2, Mid_Byte
  Out ADDRESS + 3, HI
End Sub

Sub Initialize(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4
              
Index ADDRESS, X_NUMBER, 1000
MOTION ADDRESS, X_NUMBER, 200, 4000, 200000
SET_ENCODER ADDRESS, X_NUMBER, 0
LIMIT_CONTROL ADDRESS, X_NUMBER, 1, 1, 1
SET_OUTPUT1 ADDRESS, 0, 0, 0, 0, 0, 1, 1
SET_OUTPUT2 ADDRESS, 0, 0, 0, 0, 0, 1, 1

End Sub

Sub LIMIT_CONTROL(Hex_Address, X_NUMBER, SOFT, MARKER, HOME)
        ADDRESS = Hex_Address + 12 + X_NUMBER * 4

        Value = 128 + 64 + 1
        If HOME = 1 Then Value = Value + 8
        If MARKER = 1 Then Value = Value + 4
        If SOFT = 1 Then Value = Value + 2
        Out ADDRESS, Value
End Sub

Sub MOTION(Hex_Address, X_NUMBER, Base_Speed, MAX_Speed, RAMP_Value)
  ADDRESS = Hex_Address + 12 + X_NUMBER * 4

         OPTIMUM_FACTOR = 300! * 16383 / MAX_Speed
         FACTOR = Int(OPTIMUM_FACTOR)
         If FACTOR < 2 Then FACTOR = 2
         If FACTOR > 16383 Then FACTOR = 16383
                Call GET_LO_Mid_HI(FACTOR, HI, Mid_Byte, LO)
                Out ADDRESS, 128 + 4
                Out ADDRESS + 1, LO
                Out ADDRESS + 2, Mid_Byte
                Out ADDRESS + 3, HI
        MAX_SETTING = Int(MAX_Speed * FACTOR / 300)
            If MAX_SETTING > 16383 Then MAX_SETTING = 16383
                Call GET_LO_Mid_HI(MAX_SETTING, HI, Mid_Byte, LO)
                Out ADDRESS, 128 + 2
                Out ADDRESS + 1, LO
                Out ADDRESS + 2, Mid_Byte
                Out ADDRESS + 3, HI
        RAMP_SETTING = Int((150! * 9830400) / (RAMP_Value * FACTOR))
        If RAMP_SETTING < 1 Then RAMP_SETTING = 1
        If RAMP_SETTING > 32767 Then RAMP_SETTING = 32767
  Call GET_LO_Mid_HI(RAMP_SETTING, HI, Mid_Byte, LO)
                Out ADDRESS, 128 + 3
                Out ADDRESS + 1, LO
                Out ADDRESS + 2, Mid_Byte
                Out ADDRESS + 3, HI
        BASE_SETTING = Int(Base_Speed * FACTOR / 300)
        If BASE_SETTING < 1 Then BASE_SETTING = 1
                Call GET_LO_Mid_HI(BASE_SETTING, HI, Mid_Byte, LO)
                Out ADDRESS, 128 + 1
                Out ADDRESS + 1, LO
                Out ADDRESS + 2, Mid_Byte
                Out ADDRESS + 3, HI
End Sub

Sub ONE_AT_MAX_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 29
End Sub

Sub ONE_AT_MAX_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 25
End Sub

Sub ORIGIN_INDEX_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 114
       Out ADDRESS, 23
End Sub

Sub ORIGIN_INDEX_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 114
       Out ADDRESS, 18
End Sub

Sub POSITION(Hex_Address, X_NUMBER, Setting)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

    Num_to_Index = Setting - READ_POSITION(Hex_Address, X_NUMBER)
    If Num_to_Index > 0 Then
        Index Hex_Address, X_NUMBER, Num_to_Index
        GO_CW Hex_Address, X_NUMBER
    Else
        Index Hex_Address, X_NUMBER, Abs(Num_to_Index)
        GO_CCW Hex_Address, X_NUMBER
    End If
End Sub

Sub RAMP_TO_BASE_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 6
End Sub

Sub RAMP_TO_BASE_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 2
End Sub

Sub RAMP_TO_STOP_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4
       Out ADDRESS, 14
End Sub

Sub RAMP_TO_STOP_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4
       Out ADDRESS, 10
End Sub

Function READ_ENCODER(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 128 + 8
       Out ADDRESS + 1, 1
       Out ADDRESS + 2, 44
     
       Out ADDRESS, 128 + 13
        BB = Inp(ADDRESS + 1)
        CC = Inp(ADDRESS + 2)
        DD = Inp(ADDRESS + 3)
       Encoder_Value = BB + CC * 256 + DD * 256 * 256
    If Encoder_Value > 8388608 Then
                Encoder_Value = (Encoder_Value - 16777216)
    End If
    READ_ENCODER = Encoder_Value
End Function

Function READ_POSITION(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 128 + 8
       Out ADDRESS + 1, 1
       Out ADDRESS + 2, 44
       Out ADDRESS, 128 + 12
        BB = Inp(ADDRESS + 1)
        CC = Inp(ADDRESS + 2)
        DD = Inp(ADDRESS + 3)
       READ_POSITION = BB + CC * 256 + DD * 256 * 256
End Function

Sub SET_ENCODER(Hex_Address, X_NUMBER, Setting)
  ADDRESS = Hex_Address + 12 + X_NUMBER * 4
      
       'ENCODER SETUP INFORMATION
       Out ADDRESS, 128 + 8
       Out ADDRESS + 1, 1
       Out ADDRESS + 2, 44

  Call GET_LO_Mid_HI(Setting, HI, Mid_Byte, LO)
  Out ADDRESS, 128 + 7
  Out ADDRESS + 1, LO
  Out ADDRESS + 2, Mid_Byte
  Out ADDRESS + 3, HI
End Sub

Sub SET_OUTPUT1(Hex_Address, OUT5, OUT4, OUT3, OUT2, OUT1, A_HOME_DIR, B_HOME_DIR)
        ' a 1 for A_HOME_DIR = CW
        ' a 0 for A_HOME_DIR = CCW
   ADDRESS = Hex_Address + 4

   Value = OUT5 * 16 + OUT4 * 8 + OUT3 * 4 + OUT2 * 2 + OUT1
   If A_HOME_DIR = 0 Then Value = Value + 64
   If B_HOME_DIR = 0 Then Value = Value + 128
   Out ADDRESS, Value
End Sub

Sub SET_OUTPUT2(Hex_Address, OUT10, OUT9, OUT8, OUT7, OUT6, C_HOME_DIR, D_HOME_DIR)
        ' a 1 for A_HOME_DIR = CW
        ' a 0 for A_HOME_DIR = CCW
       ADDRESS = Hex_Address + 12

   Value = OUT10 * 16 + OUT9 * 8 + OUT8 * 4 + OUT7 * 2 + OUT6
   If C_HOME_DIR = 0 Then Value = Value + 64
   If D_HOME_DIR = 0 Then Value = Value + 128
   Out ADDRESS, Value

End Sub

Sub SET_POSITION(Hex_Address, X_NUMBER, Setting)
  ADDRESS = Hex_Address + 12 + X_NUMBER * 4

'      SET UP
       Out ADDRESS, 128 + 8
       Out ADDRESS + 1, 1
       Out ADDRESS + 2, 44
 
  Call GET_LO_Mid_HI(Setting, HI, Mid_Byte, LO)
  Out ADDRESS, 128 + 6
  Out ADDRESS + 1, LO
  Out ADDRESS + 2, Mid_Byte
  Out ADDRESS + 3, HI
End Sub

Sub SLEW_AT_BASE_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 64
       Out ADDRESS, 20
End Sub

Sub SLEW_AT_BASE_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 64
       Out ADDRESS, 16
End Sub

Function SOFT_INPUT_CCW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 131
       LIMITS = Inp(ADDRESS + 1)
       LIMITS = LIMITS - 128
       If LIMITS \ 64 = 1 Then LIMITS = LIMITS - 64
       If LIMITS \ 32 = 1 Then LIMITS = LIMITS - 32
       If LIMITS \ 16 = 1 Then LIMITS = LIMITS - 16
       If LIMITS \ 8 = 1 Then
                SOFT_INPUT_CCW = 1
        Else
                SOFT_INPUT_CCW = 0
        End If
    
End Function

Function SOFT_INPUT_CW(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       Out ADDRESS, 131
       LIMITS = Inp(ADDRESS + 1)
       LIMITS = LIMITS - 128
       If LIMITS \ 64 = 1 Then LIMITS = LIMITS - 64
       If LIMITS \ 32 = 1 Then LIMITS = LIMITS - 32
       If LIMITS \ 16 = 1 Then LIMITS = LIMITS - 16
       If LIMITS \ 8 = 1 Then LIMITS = LIMITS - 8
       If LIMITS \ 4 = 1 Then
                SOFT_INPUT_CW = 1
        Else
                SOFT_INPUT_CW = 0
        End If
     
End Function

Sub Stop_Motion(Hex_Address, X_NUMBER)
       ADDRESS = Hex_Address + 12 + X_NUMBER * 4

       If BUSY(Hex_Address, X_NUMBER) = 1 Then Out ADDRESS, 8
End Sub

Sub WAIT_FOR_STOP(Hx_Address, X_NUMBER)
       While BUSY(Hx_Address, X_NUMBER) = 1
       Wend
End Sub

